--------------------------------------------------------------------------------
-- Buff: Featherweight by Holzchopf
-- v1.1 - 07 Oct 2011	- Fixed bug of showing info after usage
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.featherweight={}
holzchopf.featherweight.buff={}
holzchopf.featherweight.gfx_buff=loadgfx("holzchopf/buff_featherweight.png")
setmidhandle(holzchopf.featherweight.gfx_buff)
holzchopf.featherweight.gfx_icn=loadgfx("holzchopf/buff_featherweighticon.png")
setmidhandle(holzchopf.featherweight.gfx_icn)
holzchopf.featherweight.sfx_buff=loadsfx("holzchopf/buff.wav")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.featherweight.id=addweapon("holzchopf.featherweight","Buff: Featherweight",holzchopf.featherweight.gfx_icn,1)

function holzchopf.featherweight.draw()
	if weapon_shots==0 then
		hudinfo("Hit [attack] to activate Featherweight")
	end
end

function holzchopf.featherweight.attack(attack)
	if attack==1 and weapon_shots==0 then
		local player=playercurrent()
		createobject(holzchopf.featherweight.buff.id, getplayerx(player),getplayery(player),player)
		weapon_shots=1
		useweapon(0)
		endturn()
		-- fx
		particle(p_ring,getplayerx(0),getplayery(0))
		particlecolor(204,255,0)
		playsound(holzchopf.featherweight.sfx_buff)
	end
end

--------------------------------------------------------------------------------
-- Buff
--------------------------------------------------------------------------------
holzchopf.featherweight.buff.id=addobject("holzchopf.featherweight.buff",0)

function holzchopf.featherweight.buff.setup(id,player)
	-- set up buff
	objects[id]={}
	objects[id].isbuff=true
	objects[id].player=player
end

function holzchopf.featherweight.buff.draw(id)
	local p=objects[id].player
	-- do not draw at all if player is invisible
	if getplayerstate(p,state_invisible)==1 then return 0 end
	local x=getplayerx(p)
	local y=getplayery(p)
	local t=getframe()/20
	setblend(blend_light)
	setcolor(192,255,0)
	setrotation(0)
	setscale(1,1)
	for i=0,3 do
		local a=t+math.pi/4*i
		local dy=10-10*math.mod(a,math.pi)
		local dx=math.mod(i,1.5)*4-3
		setalpha(0.3*math.sin(a)^2)
		drawimage(holzchopf.featherweight.gfx_buff,x+dx,y+dy)
	end
end

function holzchopf.featherweight.buff.update(id)
	local p=objects[id].player
	-- remove if player is dead
	if getplayerhealth(p)<=0 then
		removeobject(id)
		return 0
	end
	-- push player when falling
	if getplayeraction(p)~=0 then
		-- wind influence and speed limitation
		local sx=getplayerxspeed(p)
		local sy=getplayeryspeed(p)
		sx=math.atan(sx/20+getwind()/50)*20
		sy=math.atan(sy/20)*20
		playerpush(p,sx,sy,1,0)
	end
	return 0 -- (allow to) end turn
end

function holzchopf.featherweight.buff.damage(id,damage)
end