--------------------------------------------------------------------------------
-- Buff: Vitality by Holzchopf
-- v1.1 - 07 Oct 2011	- Tweaked around the use of getturn()
--						- Fixed bug of showing info after usage
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.buffvitality={}
holzchopf.buffvitality.buff={}
holzchopf.buffvitality.gfx_icn=loadgfx("holzchopf/buff_vitalityicon.png")
setmidhandle(holzchopf.buffvitality.gfx_icn)
holzchopf.buffvitality.sfx_buff=loadsfx("holzchopf/buff.wav")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.buffvitality.id=addweapon("holzchopf.buffvitality","Buff: Vitality",holzchopf.buffvitality.gfx_icn,0,2)

function holzchopf.buffvitality.draw()
	if weapon_shots==0 then
		hudinfo("Hit [attack] to activate Vitality")
	end
end

function holzchopf.buffvitality.attack(attack)
	if attack==1 and weapon_shots==0 then
		local player=playercurrent()
		createobject(holzchopf.buffvitality.buff.id, getplayerx(player),getplayery(player),player)
		weapon_shots=1
		useweapon(0)
		endturn()
		-- fx
		particle(p_ring,getplayerx(0),getplayery(0))
		particlecolor(0,255,0)
		playsound(holzchopf.buffvitality.sfx_buff)
	end
end

--------------------------------------------------------------------------------
-- Buff
--------------------------------------------------------------------------------
holzchopf.buffvitality.buff.id=addobject("holzchopf.buffvitality.buff",0)

function holzchopf.buffvitality.buff.setup(id,player)
	-- set up buff
	objects[id]={}
	objects[id].isbuff=true
	objects[id].player=player
	objects[id].turn=0
end

function holzchopf.buffvitality.buff.draw(id)
	local p=objects[id].player
	-- do not draw at all if player is invisible
	if getplayerstate(p,state_invisible)==1 then return 0 end
	local x=getplayerx(p)
	local y=getplayery(p)
	particle(p_muzzle,x,y)
	particlecolor(0,255,0)
	particlealpha(0.3)
	particlefadealpha(1)
		particle(p_flare,x,y)
		particlespeed(math.random(-3,3)*0.1,math.random(-3,3)*0.1)
		particlecolor(0,255,0)
		particlesize(2,2)
		particlealpha(0.4)
		particlefadealpha(0.01)
end

function holzchopf.buffvitality.buff.update(id)
	local p=objects[id].player
	-- remove if player is dead
	if getplayerhealth(p)<=0 then
		removeobject(id)
		return 0
	end
	-- heal player every new turn
	if getframesleft()==0 then
		objects[id].turn=1
	elseif objects[id].turn==1 then
		objects[id].turn=0
		playerheal(p,2)
	end
	return 0 -- (allow to) end turn
end

function holzchopf.buffvitality.buff.damage(id,damage)
end