--------------------------------------------------------------------------------
-- Debuff by holzchopf
--------------------------------------------------------------------------------

-- setup
if holzchopf==nil then holzchopf={} end
holzchopf.debuff={}
holzchopf.debuff.gfx_wpn=loadgfx("holzchopf/debufficon.png")
setmidhandle(holzchopf.debuff.gfx_wpn)
holzchopf.debuff.sfx_debuff=loadsfx("holzchopf/debuff.wav")

--------------------------------------------------------------------------------
-- Weapon
--------------------------------------------------------------------------------
holzchopf.debuff.id=addweapon("holzchopf.debuff","Debuff",holzchopf.debuff.gfx_wpn,0,3)

function holzchopf.debuff.draw()
	if weapon_shots==0 then
		hudinfo("Hit [attack] to debuff enemy players!")
	end
end

function holzchopf.debuff.attack(attack)
	if attack==1 then
		-- use weapon
		weapon_shots=weapon_shots+1
		useweapon(0)
		endturn()
		-- debuff enemies
		local players=playertable(3)
		local objs=objecttable()
		local debuffed=0
		for i=1,#objs do
			local object=objects[objs[i]]
			-- is buff
			if object~=nil then
				if object.isbuff~=nil then
					-- belongs to enemy
					for p=1,#players do
						if object.player==players[p] then
							-- remove buff
							removeobject(objs[i])
							debuffed=1
							-- fx
							particle(p_muzzle,getplayerx(players[p]),getplayery(players[p]))
							particlecolor(255,0,0)
							particlefadealpha(0.02)
							particlesize(2,2)
							particle(p_muzzle,getplayerx(players[p]),getplayery(players[p]))
							particlecolor(255,255,0)
							particlefadealpha(0.02)
							particlesize(1,1)
							particle(p_ring,getplayerx(players[p]),getplayery(players[p]))
							particlecolor(255,0,0)
						end
					end
				end
			end
		end
		-- sfx
		if debuffed==1 then playsound(holzchopf.debuff.sfx_debuff) end
	end
end